package com.example.myapplication.database.repository

import com.example.myapplication.database.dao.UserDao
import com.example.myapplication.database.entities.User
import com.example.myapplication.database.entities.UserProductCart
import com.example.myapplication.database.entities.UserWithCartProduct
import kotlinx.coroutines.flow.Flow

class OfflineUserRepository(private val userDao: UserDao) : UserRepository {
    override fun getAll(): Flow<List<User>> = userDao.getAll()
    override fun getById(id: Int): Flow<User> = userDao.getById(id)
    override fun getByAuth(login: String, password: String): Flow<User?> = userDao.getByAuth(login, password)
    override fun getUserProductCartById(id: Int): Flow<UserWithCartProduct> = userDao.getUserProductCartById(id)
    override suspend fun deleteCartProduct(userId: Int, productId: Int) = userDao.deleteCartProduct(userId, productId)
    override suspend fun insert(user: User) = userDao.insert(user)
    override suspend fun addProductCart(userItem: UserProductCart) = userDao.addProductCart(userItem)
}