package com.example.myapplication.database.repository

import com.example.myapplication.database.entities.User
import com.example.myapplication.database.entities.UserProductCart
import com.example.myapplication.database.entities.UserWithCartProduct
import kotlinx.coroutines.flow.Flow

interface UserRepository {
    fun getAll(): Flow<List<User>>
    fun getById(id: Int): Flow<User>
    fun getByAuth(login: String, password: String): Flow<User?>
    fun getUserProductCartById(id: Int): Flow<UserWithCartProduct>
    suspend fun deleteCartProduct(userId: Int, productId: Int)
    suspend fun insert(user: User)
    suspend fun addProductCart(userItem: UserProductCart)

}